#include "clip_instance.h"

#include "clip.h"

clip_instance::clip_instance(clip* clip): clip_(clip) {
    clip_end_ = clip->get_length();
}

void clip_instance::process(int64_t sample_pos, int32_t length) {
    const int64_t clip_end = clip_end_;
    if (sample_pos >= clip_end) {
        return;
    }
    const int64_t clip_begin = clip_begin_;
    if (sample_pos + length <= clip_begin) {
        return;
    }
    const int64_t clip_length = clip_end - clip_begin;
    const int64_t clip_pos = sample_pos - clip_begin;
    const int64_t clip_length_remaining = clip_length - clip_pos;
    const int64_t length_remaining = length - clip_length_remaining;
    if (clip_length_remaining < length) {
        clip_->process(clip_pos, clip_length_remaining);
        clip_begin_ = clip_end;
        if (length_remaining > 0) {
            process(sample_pos + clip_length_remaining, length_remaining);
        }
    } else {
        clip_->process(clip_pos, length);
    }
}
