#pragma once
#include <unordered_map>

#include "../../misc/mempool.h"
#include "misc/singleton/singleton.h"

class CORE_API audio_buffer_pool : public singleton_t<audio_buffer_pool> {
public:
    void init(singleton_initliazer& initliazer) override;
    void release(singleton_release_guard& release_guard) override;
    const char* get_name() override { return "audio_buffer_pool"; }

    sample_t* alloc(uint32_t block_size);
    void free(sample_t* block, uint32_t block_size);
protected:
private:
    std::unordered_map<uint32_t, memory_pool*> pool_map_;
};

DEFINE_SINGLETON_INSTANCE(audio_buffer_pool)
